package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.course.bo.CourseAddBo;
import com.zhongzheng.modules.course.bo.CourseEditBo;
import com.zhongzheng.modules.course.bo.CourseQueryBo;
import com.zhongzheng.modules.course.domain.Course;
import com.zhongzheng.modules.course.mapper.CourseMapper;
import com.zhongzheng.modules.course.mapper.CourseSectionMapper;
import com.zhongzheng.modules.course.service.ICourseSectionBusinessService;
import com.zhongzheng.modules.course.service.ICourseService;
import com.zhongzheng.modules.course.vo.CourseVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程Service业务层处理
 *
 * @author hjl
 * @date 2021-10-09
 */
@Service
public class CourseServiceImpl extends ServiceImpl<CourseMapper, Course> implements ICourseService {

    @Autowired
    private CourseMapper courseMapper;

    @Override
    public CourseVo queryById(Long courseId){
        Course db = this.baseMapper.selectById(courseId);
        return BeanUtil.toBean(db, CourseVo.class);
    }

    @Override
    public CourseVo selectById(Long id) {
        return courseMapper.selectDetailById(id);
    }

    @Override
    public List<CourseVo> queryList(CourseQueryBo bo) {
        LambdaQueryWrapper<Course> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getPrefixName()), Course::getPrefixName, bo.getPrefixName());
        lqw.eq(StrUtil.isNotBlank(bo.getCoverUrl()), Course::getCoverUrl, bo.getCoverUrl());
        lqw.eq(StrUtil.isNotBlank(bo.getIntroduction()), Course::getIntroduction, bo.getIntroduction());
        lqw.eq(bo.getStatus() != null, Course::getStatus, bo.getStatus());
        lqw.eq(bo.getEducationTypeId() != null, Course::getEducationTypeId, bo.getEducationTypeId());
        lqw.eq(bo.getBusinessId() != null, Course::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getSchoolId() != null, Course::getSchoolId, bo.getSchoolId());
        lqw.like(StrUtil.isNotBlank(bo.getCourseName()), Course::getCourseName, bo.getCourseName());
        lqw.eq(bo.getPublishStatus() != null, Course::getPublishStatus, bo.getPublishStatus());
        lqw.eq(bo.getSort() != null, Course::getSort, bo.getSort());
        lqw.eq(StrUtil.isNotBlank(bo.getSuitableObject()), Course::getSuitableObject, bo.getSuitableObject());
        lqw.eq(StrUtil.isNotBlank(bo.getPcDetailHtml()), Course::getPcDetailHtml, bo.getPcDetailHtml());
        lqw.eq(StrUtil.isNotBlank(bo.getMobileDetailHtml()), Course::getMobileDetailHtml, bo.getMobileDetailHtml());
        lqw.eq(bo.getMajorId() != null, Course::getMajorId, bo.getMajorId());
        lqw.eq(StrUtil.isNotBlank(bo.getCode()), Course::getCode, bo.getCode());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<CourseVo> selectList(CourseQueryBo bo) {
        return courseMapper.selectCourseList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseVo> entity2Vo(Collection<Course> collection) {
        List<CourseVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Course> page = (Page<Course>)collection;
            Page<CourseVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Long insertByAddBo(CourseAddBo bo) {
        Course add = BeanUtil.toBean(bo, Course.class);
        add.setCode(ServletUtils.getEncoded("KC"));
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        this.save(add);
        return add.getCourseId();
    }

    @Override
    public Boolean updateByEditBo(CourseEditBo bo) {
        Course update = BeanUtil.toBean(bo, Course.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Course entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
